Subject: Re: [PATCH v3] multi-pack-index: fix *.rev cleanups with --object-dir

From: Junio C Hamano <[email-masked]>
Date: Tue, 24 Aug 2021 12:01:51 -0700

Johannes Berg <[email-masked]> writes:

> On Mon, 2021-08-23 at 15:44 -0700, Junio C Hamano wrote:
>> Johannes Berg <[email-masked]> writes:
>> 
>> > If using --object-dir to point into a repo while the current
>> > working dir is outside, such as
>> > 
>> >   git init /repo
>> >   git -C /repo ... # add some objects
>> >   cd /non-repo
>> >   git multi-pack-index --object-dir /repo/.git/objects/ write
>> > 
>> > the binary will segfault trying to access the object-dir via
>> > the repo it found, but that's not fully initialized. Fix it
>> 
>> OK, so write_midx_internal() was given an object_dir to work in,
>> made various changes to that directory, but at the very end of the
>> sequence, instead of clearing the revindex in the object_dir we have
>> been working in, cleared the odb associated with the repository.
>
> I'm not sure I'd claim "cleared the odb" but it's also not entirely
> clear to me what you mean by that.

"cleared the revindex in the wrong odb" is what I meant to say.